using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Kronos._1_Modelos;
using static Exferia_Aplicacion.General.Enumerados;
using System.Transactions;
using System.Data.SqlClient;
using System.Threading;
using System.Reflection;

namespace Exferia_Kronos._2_Datos
{
    public class KRO_Notificaciones_Datos : ABS_Datos
    {
        #region Listados
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                string str_SQL =
                        " SELECT " +
                            nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.id) + "," +
                            nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.idTareaProgramada) + "," +
                            nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.tipo) + "," +
                            nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.idConfiguracionEmail) + "," +
                            nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.notificarSiError) +
                        " FROM " + nameof(KRO_Notificaciones) +
                        " WHERE  " + nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<KRO_Notificaciones>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //KRO_TareasProgramadas ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idTareaProgramada != null)
                    {
                        ThreadStart obj_ThreadStart_TAREAPROGRAMADA = new ThreadStart(Obtener_TareaProgramada_Modelo_Obtener);
                        Thread obj_Thread_TAREAPROGRAMADA = new Thread(obj_ThreadStart_TAREAPROGRAMADA);
                        obj_Thread_TAREAPROGRAMADA.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }
                        

                    //GEN_ConfiguracionesEmails ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idConfiguracionEmail != null)
                    {
                        ThreadStart obj_ThreadStart_CONFIGURACIONEMAIL = new ThreadStart(Obtener_ConfiguracionEmail_Modelo_Obtener);
                        Thread obj_Thread_CONFIGURACIONEMAIL = new Thread(obj_ThreadStart_CONFIGURACIONEMAIL);
                        obj_Thread_CONFIGURACIONEMAIL.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacioandas
        private void Obtener_TareaProgramada_Modelo_Obtener()
        {
            try
            {
                KRO_TareasProgramadas_Datos obj_KRO_TareasProgramadas_Datos = new KRO_TareasProgramadas_Datos();
                g_dnm_Modelo_Obtener.KRO_TareasProgramadas = obj_KRO_TareasProgramadas_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idTareaProgramada);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_ConfiguracionEmail_Modelo_Obtener()
        {
            try
            {
                g_dnm_Modelo_Obtener.GEN_ConfiguracionesEmails = Datos_Generales.GEN_ConfiguracionesEmails_Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idConfiguracionEmail);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private KRO_Notificaciones g_mdl_KRO_Notificaciones = null;

        public KRO_Notificaciones Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRO_Notificaciones;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_KRO_Notificaciones = obj_Exferia_Entities.Database.SqlQuery<KRO_Notificaciones>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Modelo Listado
        private List<KRO_Notificaciones> g_lst_KRO_Notificaciones = null;

        public List<KRO_Notificaciones> Obtener_ModeloListado_Por_Por_IdTareaprogramada(long _lng_idTareaProgramada,
                                                                                        bool _bol_Cargar_NotificacionesDestinos,
                                                                                        bool _bol_Cargar_ConfiguracionesEmails)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(KRO_Notificaciones) + "." + nameof(KRO_Notificaciones.idTareaProgramada) + "=@idTareaProgramada ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idTareaProgramada",  _lng_idTareaProgramada)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_NotificacionesDestinos,
                                                 _bol_Cargar_ConfiguracionesEmails);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Por_IdTareaprogramada), true);
            }

            return g_lst_KRO_Notificaciones;
        }

        public List<KRO_Notificaciones> Obtener_ModeloListado_Por_IdsTareaProgramanadas(List<long> _lst_IdsTareaProgramada,
                                                                                            bool _bol_Cargar_NotificacionesDestinos,
                                                                                            bool _bol_Cargar_ConfiguracionesEmails)
        {
            try
            {
                if (_lst_IdsTareaProgramada != null && _lst_IdsTareaProgramada.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRO_Notificaciones) ,
                                                                                            nameof(KRO_Notificaciones.idTareaProgramada),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_IdsTareaProgramada);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " + str_Filtro_IDS;

                    //Parametros
                    object[] arr_Parametros = lst_Parametros.ToArray();

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     arr_Parametros,
                                                     _bol_Cargar_NotificacionesDestinos,
                                                     _bol_Cargar_ConfiguracionesEmails);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsTareaProgramanadas), true);
            }

            return g_lst_KRO_Notificaciones;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<KRO_Notificaciones_Destinos> g_lst_KRO_Notificaciones_Destinos = null;
        private List<GEN_ConfiguracionesEmails> g_lst_GEN_ConfiguracionesEmails = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros,
                                                    bool _bol_Cargar_NotificacionesDestinos,
                                                    bool _bol_Cargar_ConfiguracionesEmails)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRO_Notificaciones = obj_Exferia_Entities.Database.SqlQuery<KRO_Notificaciones>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_KRO_Notificaciones != null && g_lst_KRO_Notificaciones.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_NotificacionesDestinos ||
                        _bol_Cargar_ConfiguracionesEmails)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //KRO_Notificaciones_DEstinos #############################################
                        if (_bol_Cargar_NotificacionesDestinos)
                        {
                            ThreadStart obj_ThreadStart_NOTIFICACIONES_DESTINOS = new ThreadStart(Obtener_NotifiacionesDestinos_Modelo_Listado);
                            Thread obj_Thread_NOTIFICACIONES_DESTINOS = new Thread(obj_ThreadStart_NOTIFICACIONES_DESTINOS);
                            obj_Thread_NOTIFICACIONES_DESTINOS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //GEN_ConfiguracionesEmails #############################################
                        if (_bol_Cargar_ConfiguracionesEmails)
                        {
                            ThreadStart obj_ThreadStart_CONFIGURACIONESEMAILS = new ThreadStart(Obtener_ConfiguracionesEmails_Modelo_Listado);
                            Thread obj_Thread_CONFIGURACIONESEMAILS = new Thread(obj_ThreadStart_CONFIGURACIONESEMAILS);
                            obj_Thread_CONFIGURACIONESEMAILS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (KRO_Notificaciones mdl_KRO_Notificaciones in g_lst_KRO_Notificaciones)
                        {
                            //KRO_NotificacionesDestinos #############################################
                            if (_bol_Cargar_NotificacionesDestinos &&
                                g_lst_KRO_Notificaciones_Destinos != null &&
                                g_lst_KRO_Notificaciones_Destinos.Count > 0)
                            {
                                mdl_KRO_Notificaciones.KRO_Notificaciones_Destinos = g_lst_KRO_Notificaciones_Destinos.Where(m => m.idNotificacion == mdl_KRO_Notificaciones.id).ToList();
                            }

                            //GEN_ConfiguracionesEmails #############################################
                            if (_bol_Cargar_ConfiguracionesEmails &&
                                mdl_KRO_Notificaciones.idConfiguracionEmail != null &&
                                g_lst_GEN_ConfiguracionesEmails != null &&
                                g_lst_GEN_ConfiguracionesEmails.Count > 0)
                            {
                                mdl_KRO_Notificaciones.GEN_ConfiguracionesEmails = g_lst_GEN_ConfiguracionesEmails.Where(m => m.id == mdl_KRO_Notificaciones.idConfiguracionEmail.Value).FirstOrDefault();
                            }
                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_NotifiacionesDestinos_Modelo_Listado()
        {
            try
            {
                KRO_Notificaciones_Destinos_Datos obj_KRO_Notificaciones_Destinos_Datos = new KRO_Notificaciones_Destinos_Datos();
                g_lst_KRO_Notificaciones_Destinos = obj_KRO_Notificaciones_Destinos_Datos.Obtener_ModeloListado_Por_IdsNotificacion(g_lst_KRO_Notificaciones.Select(m => m.id).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_ConfiguracionesEmails_Modelo_Listado()
        {
            try
            {
                g_lst_GEN_ConfiguracionesEmails = Datos_Generales.GEN_ConfiguracionesEmails_Obtener_Modelo_Listado_Por_Ids(g_lst_KRO_Notificaciones.Where(x => x.idConfiguracionEmail != null).Select(m => m.idConfiguracionEmail.Value).ToList());
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRO_Notificaciones.id) + "," +
                    nameof(KRO_Notificaciones.idTareaProgramada) + "," +
                    nameof(KRO_Notificaciones.tipo) + "," +
                    nameof(KRO_Notificaciones.idConfiguracionEmail) + "," +
                    nameof(KRO_Notificaciones.notificarSiError) +
                " FROM " + nameof(KRO_Notificaciones);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                KRO_Notificaciones mdl_KRO_Notificaciones_AGrabar = (KRO_Notificaciones)_mdl_obj;
                KRO_Notificaciones mdl_KRO_Notificaciones_DatosViejos = new KRO_Notificaciones();

                // Ver si existe ######################################################################
                KRO_Notificaciones mdl_KRO_Notificaciones_Final = Obtener_Modelo_Por_Id(mdl_KRO_Notificaciones_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_KRO_Notificaciones_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;
                    
                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_KRO_Notificaciones_Final, mdl_KRO_Notificaciones_DatosViejos, false, false);

                    //Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRO_Notificaciones_AGrabar, mdl_KRO_Notificaciones_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRO_Notificaciones) +
                                           " SET " +
                                               nameof(KRO_Notificaciones.idTareaProgramada) + "=@idTareaProgramada," +
                                               nameof(KRO_Notificaciones.tipo) + "=@tipo," +
                                               nameof(KRO_Notificaciones.idConfiguracionEmail) + "=@idConfiguracionEmail," +
                                               nameof(KRO_Notificaciones.notificarSiError) + "=@notificarSiError" +
                                           " WHERE " +
                                               nameof(KRO_Notificaciones.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idTareaProgramada",  mdl_KRO_Notificaciones_Final.idTareaProgramada),
                         new SqlParameter("@tipo",  mdl_KRO_Notificaciones_Final.tipo),
                         mdl_KRO_Notificaciones_Final.idConfiguracionEmail != null
                            ?   new SqlParameter("@idConfiguracionEmail", mdl_KRO_Notificaciones_Final.idConfiguracionEmail.Value)
                            :   new SqlParameter("@idConfiguracionEmail",  DBNull.Value),
                         mdl_KRO_Notificaciones_Final.notificarSiError != null
                            ?   new SqlParameter("@notificarSiError", mdl_KRO_Notificaciones_Final.notificarSiError)
                            :   new SqlParameter("@notificarSiError",  DBNull.Value),
                         new SqlParameter("@id",  mdl_KRO_Notificaciones_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRO_Notificaciones_Final.id;
                }
                //INSERT
                else
                {
                    mdl_KRO_Notificaciones_Final = new KRO_Notificaciones();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRO_Notificaciones_AGrabar, mdl_KRO_Notificaciones_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRO_Notificaciones) +
                                              " (" +
                                                      nameof(KRO_Notificaciones.idTareaProgramada) + "," +
                                                      nameof(KRO_Notificaciones.tipo) + "," +
                                                      nameof(KRO_Notificaciones.idConfiguracionEmail) + "," +
                                                      nameof(KRO_Notificaciones.notificarSiError) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(KRO_Notificaciones.id) +
                                              " VALUES " +
                                              " ( " +
                                                   "@idTareaProgramada," +
                                                   "@tipo," +
                                                   "@idConfiguracionEmail," +
                                                   "@notificarSiError" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idTareaProgramada",  mdl_KRO_Notificaciones_Final.idTareaProgramada),
                         new SqlParameter("@tipo",  mdl_KRO_Notificaciones_Final.tipo),
                         mdl_KRO_Notificaciones_Final.idConfiguracionEmail != null
                            ?   new SqlParameter("@idConfiguracionEmail", mdl_KRO_Notificaciones_Final.idConfiguracionEmail.Value)
                            :   new SqlParameter("@idConfiguracionEmail",  DBNull.Value),
                         mdl_KRO_Notificaciones_Final.notificarSiError != null
                            ?   new SqlParameter("@notificarSiError", mdl_KRO_Notificaciones_Final.notificarSiError)
                            :   new SqlParameter("@notificarSiError",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazailidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(KRO_Notificaciones), mdl_KRO_Notificaciones_DatosViejos, mdl_KRO_Notificaciones_DatosViejos, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    KRO_Notificaciones mdl_KRO_Notificaciones_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    if (mdl_KRO_Notificaciones_Final != null)
                    {
                        #region Delete
                        string str_SQL_Delete = " DELETE FROM  " + nameof(KRO_Notificaciones) +
                                                " WHERE " +
                                                    nameof(KRO_Notificaciones.id) + "=@id";
                        //Parametros
                        object[] arr_Parametros_Delete = new object[]
                        {
                        new SqlParameter("@id", _lng_id)
                        };
                        #endregion

                        //Delete
                        obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                        //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                        Datos_Generales.USR_Trazabilidad_Grabar(typeof(KRO_Notificaciones), null, mdl_KRO_Notificaciones_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                    }

                    // Devolver también el Objeto
                    mdl_ValorDevuelto_Modelo.Id = _lng_id;

                    // Se termina la Transaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(KRO_Notificaciones_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
